---
title: Generate Pre-Shared Key (PSK) for IPsec tunnels
---

[Skip to content](#_top)

[API Reference](https://developers.cloudflare.com/api/go)

[Magic Transit](https://developers.cloudflare.com/api/go/resources/magic_transit)

[IPSEC Tunnels](https://developers.cloudflare.com/api/go/resources/magic_transit/subresources/ipsec_tunnels)

Copy Markdown

Open in **Claude**Open in **ChatGPT**Open in **Cursor**

---

**Copy Markdown****View as Markdown**

# Generate Pre-Shared Key (PSK) for IPsec tunnels

client.MagicTransit.IPSECTunnels.PSKGenerate(ctx, ipsecTunnelID, body) (\*[IPSECTunnelPSKGenerateResponse](<https://developers.cloudflare.com/api/go/resources/magic_transit#(resource)%20magic_transit.ipsec_tunnels%20%3E%20(model)%20IPSECTunnelPSKGenerateResponse%20%3E%20(schema)>), error)

POST/accounts/{account\_id}/magic/ipsec\_tunnels/{ipsec\_tunnel\_id}/psk\_generate

Generates a Pre-Shared Key for a specific IPsec tunnel used in the IKE session. Use `?validate_only=true` as an optional query parameter to only run validation without persisting changes. After a PSK is generated, the PSK is immediately persisted to Cloudflare’s edge and cannot be retrieved later. Store the PSK in a safe place.

##### Security

<details>

<summary>API Token</summary>



The preferred authorization scheme for interacting with the Cloudflare API. <a href="https://developers.cloudflare.com/fundamentals/api/get-started/create-token/">Create a token</a>.

**Example:**<code>Authorization: Bearer Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY</code>

</details>

<details>

<summary>API Email + API Key</summary>



The previous authorization scheme for interacting with the Cloudflare API, used in conjunction with a Global API key.

**Example:**<code>X-Auth-Email: user@example.com</code>

The previous authorization scheme for interacting with the Cloudflare API. When possible, use API tokens instead of Global API keys.

**Example:**<code>X-Auth-Key: 144c9defac04969c7bfad8efaa8ea194</code>

</details>

##### Accepted Permissions (at least one required)

`Magic WAN Write``Magic Transit Write`

##### ParametersExpand Collapse

ipsecTunnelID string

Identifier

maxLength32

[Link to this property](<#(resource)%20magic_transit.ipsec_tunnels%20%3E%20(method)%20psk_generate%20%3E%20(params)%20default%20%3E%20(param)%20ipsec_tunnel_id%20%3E%20(schema)>)

<details>

<summary>

body IPSECTunnelPSKGenerateParams

</summary>

AccountID param.Field\[string]

Identifier

maxLength32

<a href="#(resource)%20magic_transit.ipsec_tunnels%20%3E%20(method)%20psk_generate%20%3E%20(params)%20default%20%3E%20(param)%20account_id">Link to this property</a>

</details>

[Link to this property](<#(resource)%20magic_transit.ipsec_tunnels%20%3E%20(method)%20psk_generate%20%3E%20(params)%20default>)

##### ReturnsExpand Collapse

<details>

<summary>

type IPSECTunnelPSKGenerateResponse struct{…}

</summary>

IPSECTunnelID stringOptional

Identifier

maxLength32

<a href="#(resource)%20magic_transit.ipsec_tunnels%20%3E%20(model)%20IPSECTunnelPSKGenerateResponse%20%3E%20(schema)%20%3E%20(property)%20ipsec_tunnel_id">Link to this property</a>

PSK stringOptional

A randomly generated or provided string for use in the IPsec tunnel.

<a href="#(resource)%20magic_transit.ipsec_tunnels%20%3E%20(model)%20IPSECTunnelPSKGenerateResponse%20%3E%20(schema)%20%3E%20(property)%20psk">Link to this property</a>

<details>

<summary>

PSKMetadata <a href="https://developers.cloudflare.com/api/go/resources/magic_transit#(resource)%20magic_transit.ipsec_tunnels%20%3E%20(model)%20psk_metadata%20%3E%20(schema)">PSKMetadata</a>Optional

The PSK metadata that includes when the PSK was generated.

</summary>

LastGeneratedOn TimeOptional

The date and time the tunnel was last modified.

formatdate-time

<a href="#(resource)%20magic_transit.ipsec_tunnels%20%3E%20(model)%20IPSECTunnelPSKGenerateResponse%20%3E%20(schema)%20%3E%20(property)%20psk_metadata%20%2B%20(resource)%20magic_transit.ipsec_tunnels%20%3E%20(model)%20psk_metadata%20%3E%20(schema)%20%3E%20(property)%20last_generated_on">Link to this property</a>

</details>

<a href="#(resource)%20magic_transit.ipsec_tunnels%20%3E%20(model)%20IPSECTunnelPSKGenerateResponse%20%3E%20(schema)%20%3E%20(property)%20psk_metadata">Link to this property</a>

</details>

[Link to this property](<#(resource)%20magic_transit.ipsec_tunnels%20%3E%20(model)%20IPSECTunnelPSKGenerateResponse%20%3E%20(schema)>)

### Generate Pre-Shared Key (PSK) for IPsec tunnels

Go

HTTPTypeScriptPythonGoTerraform

```
package main

import (
  "context"
  "fmt"

  "github.com/cloudflare/cloudflare-go"
  "github.com/cloudflare/cloudflare-go/magic_transit"
  "github.com/cloudflare/cloudflare-go/option"
)

func main() {
  client := cloudflare.NewClient(
    option.WithAPIToken("Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY"),
  )
  response, err := client.MagicTransit.IPSECTunnels.PSKGenerate(
    context.TODO(),
    "023e105f4ecef8ad9ca31a8372d0c353",
    magic_transit.IPSECTunnelPSKGenerateParams{
      AccountID: cloudflare.F("023e105f4ecef8ad9ca31a8372d0c353"),
    },
  )
  if err != nil {
    panic(err.Error())
  }
  fmt.Printf("%+v\n", response.IPSECTunnelID)
}
```

200 example

```
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "result": {
    "ipsec_tunnel_id": "023e105f4ecef8ad9ca31a8372d0c353",
    "psk": "O3bwKSjnaoCxDoUxjcq4Rk8ZKkezQUiy",
    "psk_metadata": {
      "last_generated_on": "2017-06-14T05:20:00Z"
    }
  },
  "success": true
}
```

##### Returns Examples

200 example

```
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "result": {
    "ipsec_tunnel_id": "023e105f4ecef8ad9ca31a8372d0c353",
    "psk": "O3bwKSjnaoCxDoUxjcq4Rk8ZKkezQUiy",
    "psk_metadata": {
      "last_generated_on": "2017-06-14T05:20:00Z"
    }
  },
  "success": true
}
```